package exercise;

import org.junit.jupiter.api.Test;
import static org.assertj.core.api.Assertions.assertThat;

class AppTest {
    @Test
    void enlargeArrayImage() {

        String[][] image1 = {
            {"*", "*", "*", "*"},
            {"*", " ", " ", "*"},
            {"*", " ", " ", "*"},
            {"*", "*", "*", "*"},
        };

        String[][] enlargedImage1 = {
            {"*", "*", "*", "*", "*", "*", "*", "*"},
            {"*", "*", "*", "*", "*", "*", "*", "*"},
            {"*", "*", " ", " ", " ", " ", "*", "*"},
            {"*", "*", " ", " ", " ", " ", "*", "*"},
            {"*", "*", " ", " ", " ", " ", "*", "*"},
            {"*", "*", " ", " ", " ", " ", "*", "*"},
            {"*", "*", "*", "*", "*", "*", "*", "*"},
            {"*", "*", "*", "*", "*", "*", "*", "*"},
        };
        String[][] actual1 = App.duplicateValues(image1);
        assertThat(actual1).isEqualTo(enlargedImage1);

        String[][] image2 = {
            {" ", " ", "*", " ", " "},
            {" ", "*", " ", "*", " "},
            {" ", "*", " ", "*", " "},
            {"*", " ", " ", " ", "*"},
            {"*", " ", " ", " ", "*"},
            {" ", "*", " ", "*", " "},
            {" ", "*", " ", "*", " "},
            {" ", " ", "*", " ", " "},
        };

        String[][] enlargedImage2 = {
            {" ", " ", " ", " ", "*", "*", " ", " ", " ", " "},
            {" ", " ", " ", " ", "*", "*", " ", " ", " ", " "},
            {" ", " ", "*", "*", " ", " ", "*", "*", " ", " "},
            {" ", " ", "*", "*", " ", " ", "*", "*", " ", " "},
            {" ", " ", "*", "*", " ", " ", "*", "*", " ", " "},
            {" ", " ", "*", "*", " ", " ", "*", "*", " ", " "},
            {"*", "*", " ", " ", " ", " ", " ", " ", "*", "*"},
            {"*", "*", " ", " ", " ", " ", " ", " ", "*", "*"},
            {"*", "*", " ", " ", " ", " ", " ", " ", "*", "*"},
            {"*", "*", " ", " ", " ", " ", " ", " ", "*", "*"},
            {" ", " ", "*", "*", " ", " ", "*", "*", " ", " "},
            {" ", " ", "*", "*", " ", " ", "*", "*", " ", " "},
            {" ", " ", "*", "*", " ", " ", "*", "*", " ", " "},
            {" ", " ", "*", "*", " ", " ", "*", "*", " ", " "},
            {" ", " ", " ", " ", "*", "*", " ", " ", " ", " "},
            {" ", " ", " ", " ", "*", "*", " ", " ", " ", " "},
        };

        String[][] actual2 = App.duplicateValues(image2);
        assertThat(actual2).isEqualTo(enlargedImage2);

        String[][] image3 = {
            {"@", "@"},
            {"@", "|"},
            {"—", "|"},
            {"@", "|"},
            {"@", "@"},
        };

        String[][] enlargedImage3 = {
            {"@", "@", "@", "@"},
            {"@", "@", "@", "@"},
            {"@", "@", "|", "|"},
            {"@", "@", "|", "|"},
            {"—", "—", "|", "|"},
            {"—", "—", "|", "|"},
            {"@", "@", "|", "|"},
            {"@", "@", "|", "|"},
            {"@", "@", "@", "@"},
            {"@", "@", "@", "@"},
        };

        String[][] actual3 = App.duplicateValues(image3);
        assertThat(actual3).isEqualTo(enlargedImage3);
    }
}
